<?xml version="1.0" encoding="UTF-8" standalone="no"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head><meta http-equiv="Content-Type" content="text/html; charset=UTF-8" /><title>Chapter 3. The C++ API</title><link rel="stylesheet" href="synopsis.css" type="text/css" /><meta name="generator" content="DocBook XSL Stylesheets V1.73.2" /><link rel="start" href="index.html" title="Synopsis Developer's Guide" /><link rel="up" href="index.html" title="Synopsis Developer's Guide" /><link rel="prev" href="python-tests.html" title="Python Regression Tests" /><link rel="next" href="ptree.html" title="The Parse Tree Module" /></head><body><div class="navheader"><table width="100%" summary="Navigation header"><tr><th colspan="3" align="center">Chapter 3. The C++ API</th></tr><tr><td width="20%" align="left"><a accesskey="p" href="python-tests.html">Prev</a> </td><th width="60%" align="center"> </th><td width="20%" align="right"> <a accesskey="n" href="ptree.html">Next</a></td></tr></table></div><div class="chapter" lang="en" xml:lang="en"><div class="titlepage"><div><div><h2 class="title"><a id="cxx"></a>Chapter 3. The C++ API</h2></div></div></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="section"><a href="ptree.html">The Parse Tree Module</a></span></dt><dd><dl><dt><span class="section"><a href="ptree.html#encoding">The Encoding class</a></span></dt><dt><span class="section"><a href="ptree.html#ptree-display">PTree::Display</a></span></dt></dl></dd><dt><span class="section"><a href="symbol-table.html">The Symbol Table Module</a></span></dt><dd><dl><dt><span class="section"><a href="symbol-table.html#symbol-display">SymbolTable::Display</a></span></dt></dl></dd><dt><span class="section"><a href="type-analysis.html">The Type Analysis Module</a></span></dt><dd><dl><dt><span class="section"><a href="type-analysis.html#type-repository">The Type Repository</a></span></dt><dt><span class="section"><a href="type-analysis.html#overload-resolution">Overload Resolution</a></span></dt><dt><span class="section"><a href="type-analysis.html#template-repository">The Template Repository</a></span></dt><dt><span class="section"><a href="type-analysis.html#type-evaluation">Type Evaluation</a></span></dt><dt><span class="section"><a href="type-analysis.html#const-evaluation">Constant expressions</a></span></dt></dl></dd><dt><span class="section"><a href="cxx-tests.html">C++ Regression Tests</a></span></dt></dl></div><p>
      The Parser operates on an in-memory buffer of the whole (preprocessed) file.
      The generated parse tree refers to memory locations in that buffer, and it
      is possible to replace existing tree nodes by new ones, and then writing the
      modified buffer back to a file, preserving all but the modified regions.
    </p><p>
      This feature makes this parser an excellent choice for source-to-source
      transformation, as the new code doesn't need to be generated from scratch,
      but instead will preserve all features from the original file that the user
      didn't explicitely modify.
    </p><p>
      Parsing a source file involves a number of classes, such as <span class="type">Buffer</span>,
      <span class="type">Lexer</span>, <span class="type">Parser</span>, and <span class="type">SymbolFactory</span>. These
      can be constructed with a number of parameters, to control the specific language /
      language dialect (C, C++, GNU extensions, MSVC extensions, etc.).
    </p><div class="mediaobject"><img src="images/c++-frontend.png" /></div></div><div class="navfooter"><table width="100%" summary="Navigation footer"><tr><td width="40%" align="left"><a accesskey="p" href="python-tests.html">Prev</a> </td><td width="20%" align="center"> </td><td width="40%" align="right"> <a accesskey="n" href="ptree.html">Next</a></td></tr><tr><td width="40%" align="left" valign="top">Python Regression Tests </td><td width="20%" align="center"><a accesskey="h" href="index.html">Home</a></td><td width="40%" align="right" valign="top"> The Parse Tree Module</td></tr></table></div></body></html>
